package se.su.dsv.scipro.forummail;

import com.google.common.base.Function;

import javax.mail.MessagingException;
import javax.mail.Part;
import java.io.IOException;
import java.io.InputStream;

public class MailAttachment {
    private final Part part;

    public MailAttachment(final Part part) {
        this.part = part;
    }

    public String getFileName() {
        try {
            return part.getFileName();
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }

    public String getContentType() {
        try {
            return part.getContentType();
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }

    public long getSize() {
        try {
            return part.getSize();
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }

    public <T> T handleData(Function<InputStream, T> handler) {
        try (InputStream is = part.getInputStream()) {
            return handler.apply(is);
        } catch (MessagingException | IOException e) {
            throw new RuntimeException(e);
        }
    }
}
