package se.su.dsv.scipro.util;

import com.google.inject.PrivateModule;
import com.google.inject.name.Names;

import java.io.IOException;
import java.util.Properties;

public abstract class PrivatePropertyModule extends PrivateModule {

    protected abstract void configure(Properties properties);

    @Override
    protected final void configure() {
        configure(loadProperties());
    }

    private Properties loadProperties() {
        try {
            Properties properties = new Properties();
            properties.load(getClass().getResourceAsStream(getClass().getSimpleName() + ".properties"));
            return properties;
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    protected void bindProperty(Properties properties, String property) {
        bindConstant().annotatedWith(Names.named(property)).to(properties.getProperty(property));
    }
}
