package se.su.dsv.scipro.components;

import org.apache.wicket.extensions.markup.html.repeater.data.grid.ICellPopulator;
import org.apache.wicket.extensions.markup.html.repeater.data.table.PropertyColumn;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.PropertyModel;
import se.su.dsv.scipro.data.enums.DateStyle;
import se.su.dsv.scipro.date.DateService;

import javax.inject.Inject;
import java.util.Date;

public class DateColumn<T> extends PropertyColumn<T, String> {

    private final DateStyle dateStyle;

    @Inject
    DateService dateService;

    public DateColumn(IModel<String> displayModel, String propertyExpression) {
        this(displayModel, propertyExpression, DateStyle.DATE);
    }

    public DateColumn(IModel<String> displayModel, String propertyExpression, DateStyle dateStyle) {
        super(displayModel, propertyExpression);
        this.dateStyle = dateStyle;
    }

    public DateColumn(IModel<String> displayModel, String property, String sort) {
        this(displayModel, property, sort, DateStyle.DATE);
    }

    public DateColumn(IModel<String> displayModel, String property, String sort, DateStyle dateStyle) {
        super(displayModel, sort, property);
        this.dateStyle = dateStyle;
    }

    @Override
    public void populateItem(Item<ICellPopulator<T>> cellItem, String componentId, IModel<T> rowModel) {
        cellItem.add(new DateLabel(componentId, new PropertyModel<Date>(rowModel, getPropertyExpression()), dateStyle));
    }
}