package se.su.dsv.scipro.grading;

import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.markup.html.form.FormComponent;
import org.apache.wicket.model.IModel;
import org.apache.wicket.util.visit.IVisit;
import org.apache.wicket.util.visit.IVisitor;
import se.su.dsv.scipro.components.AutoSavingBehaviour;
import se.su.dsv.scipro.report.GradingReport;
import se.su.dsv.scipro.report.GradingReportService;

import javax.inject.Inject;

public class AutoSavingCriteriaPanel extends CriteriaPanel {

    @Inject
    private GradingReportService gradingReportService;

    public AutoSavingCriteriaPanel(String id, final IModel<? extends GradingReport> gradingReport) {
        super(id, gradingReport);

        visitChildren(FormComponent.class, new IVisitor<FormComponent, Void>() {
            @Override
            public void component(final FormComponent object, final IVisit<Void> visit) {
                object.add(new AutoSavingBehaviour() {
                    @Override
                    protected void onUpdate(AjaxRequestTarget target) {
                        gradingReportService.save(gradingReport.getObject());
                    }
                });
            }
        });
    }
}
