package se.su.dsv.scipro.util;

import org.apache.wicket.ajax.attributes.AjaxCallListener;
import org.apache.wicket.ajax.attributes.AjaxRequestAttributes;
import org.apache.wicket.ajax.markup.html.AjaxLink;
import org.apache.wicket.model.IModel;

public abstract class AjaxConfirmationLink<T> extends AjaxLink<T> {

    private String confirmationMessage;

    public AjaxConfirmationLink(String id, String confirmationMessage) {
        super(id);
        this.confirmationMessage = confirmationMessage;
    }

    public AjaxConfirmationLink(String id, IModel<T> model, String confirmationMessage) {
        super(id, model);
        this.confirmationMessage = confirmationMessage;
    }

    @Override
    protected void updateAjaxAttributes(AjaxRequestAttributes attributes) {
        super.updateAjaxAttributes(attributes);
        AjaxCallListener ajaxCallListener = new AjaxCallListener();
        ajaxCallListener.onPrecondition("return confirm('" + confirmationMessage + "');");
        attributes.getAjaxCallListeners().add(ajaxCallListener);
    }
}
